#include<stdio.h>
#include<windows.h>

#define TX(v)	fprintf(stderr,"TX:" #v "=0x%x %s(%d)\n",((char*)(v)),__FILE__,__LINE__);

#define COMMAND_BUF_MAX (1024*1024)

char cmd_buf[COMMAND_BUF_MAX];

int main(int argc,char*argv[])
{
	int argp=1;
	char*file_path;
	struct{
		unsigned int sout;
		unsigned int serr;
		unsigned int add;
	}flg={0};
	if(argp>=argc){fprintf(stderr,"Parameter error.\ntoo few\n");return 1;}
	file_path=argv[argp++];
	while(*argv[argp]=='/'){
		switch(argv[argp++][2]){
		case 's':case 'S':flg.sout=1;break;
		case 'e':case 'E':flg.serr=1;break;
		case 'a':case 'A':flg.add=1;break;
		default:{fprintf(stderr,"Parameter error.\nunknown parameter(%s)\n",argv[argp-1]);return 1;}
		}
	}
	int buf_pos=0;
	while(argp<argc){
		cmd_buf[buf_pos++]='\"';
		for(char*s=argv[argp++];*s!='\0';s++){
			if(*s=='\\'||*s=='\"'){cmd_buf[buf_pos++]='\\';}
			cmd_buf[buf_pos++]=*s;
		}
		cmd_buf[buf_pos++]='\"';
		cmd_buf[buf_pos++]=' ';
	}
	
	HANDLE hf=CreateFileA(file_path,GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,flg.add?OPEN_ALWAYS:CREATE_NEW,0,NULL);
	if(hf==INVALID_HANDLE_VALUE){
		fprintf(stderr,"File open error.\nfaile CreateFile(%s)\n",file_path);return 1;
	}
	SetFilePointer(hf,0,NULL,FILE_END);
	
	
	int rtn;
	HANDLE hrp;
	HANDLE hwp;
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(sa);
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = NULL;
	rtn=CreatePipe(&hrp,&hwp,&sa,0);

	PROCESS_INFORMATION pi={0};
	STARTUPINFO si={0};
	si.cb=sizeof(si);
	si.dwFlags=STARTF_USESTDHANDLES;
	si.hStdInput=hrp;
	si.hStdOutput=hwp;
	si.hStdError=hwp;
	si.wShowWindow=SW_HIDE;
	rtn=CreateProcessA(NULL,cmd_buf,NULL,NULL,TRUE,0,NULL,NULL,&si,&pi);
	
	CloseHandle(hwp);
	
	unsigned char c=0;
	DWORD read_siz=0;
	while(ReadFile(hrp,&c,1,&read_siz,NULL)&&read_siz>0){
		WriteFile(hf,&c,1,NULL,NULL);
		FlushFileBuffers(hf);
		if(flg.sout){fputc(c,stdout);}
		if(flg.serr){fputc(c,stderr);}
	}
	
	CloseHandle(hrp);
	CloseHandle(hf);
}
